---
title: WebGLRenderingContext.copyTexImage2D()
slug: Web/API/WebGLRenderingContext/copyTexImage2D
tags:
  - API
  - Method
  - Reference
  - Textures
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.copyTexImage2D()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> copies pixels from the current {{domxref("WebGLFramebuffer")}} into a 2D texture image.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.copyTexImage2D(<var>target</var>, <var>level</var>, <var>internalformat</var>, <var>x</var>, <var>y</var>, <var>width</var>, <var>height</var>, <var>border</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>target</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target) of the active texture. Possible values:
 <ul>
  <li><code>gl.TEXTURE_2D</code>: A two-dimensional texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_X</code>: Positive X face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_X</code>: Negative X face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_Y</code>: Positive Y face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_Y</code>: Negative Y face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_Z</code>: Positive Z face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_Z</code>: Negative Z face for a cube-mapped texture.</li>
 </ul>
 </dd>
 <dt><code>level</code></dt>
 <dd>A {{domxref("GLint")}} specifying the level of detail. Level 0 is the base image level and level <em>n</em> is the <em>n</em>th mipmap reduction level.</dd>
 <dt><code>internalformat</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the color components in the texture. Possible values:
 <ul>
  <li><code>gl.ALPHA</code>: Discards the red, green and blue components and reads the alpha component.</li>
  <li><code>gl.RGB</code>: Discards the alpha components and reads the red, green and blue components.</li>
  <li><code>gl.RGBA</code>: Red, green, blue and alpha components are read from the color buffer.</li>
  <li><code>gl.LUMINANCE</code>: Each color component is a luminance component, alpha is 1.0.</li>
  <li><code>gl.LUMINANCE_ALPHA</code>: Each component is a luminance/alpha component.</li>
 </ul>
 </dd>
 <dt><code>x</code></dt>
 <dd>A {{domxref("GLint")}} specifying the x coordinate of the lower left corner where to start copying.</dd>
 <dt><code>y</code></dt>
 <dd>A {{domxref("GLint")}} specifying the y coordinate of the lower left corner where to start copying.</dd>
 <dt><code>width</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the width of the texture.</dd>
 <dt><code>height</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the height of the texture.</dd>
 <dt><code>border</code></dt>
 <dd>A {{domxref("GLint")}} specifying the width of the border. Must be 0.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.copyTexImage2D(gl.TEXTURE_2D, 0, gl.RGBA, 0, 0, 512, 512, 0);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.8", "copyTexImage2D")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glCopyTexImage2D.xml", "glCopyTexImage2D")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the (similar) OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.copyTexImage2D")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.createTexture()")}}</li>
 <li>{{domxref("WebGLRenderingContext.bindTexture()")}}</li>
 <li>{{domxref("WebGLRenderingContext.texImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.texSubImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.compressedTexImage2D()")}}</li>
</ul>
